/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tonedeath;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.InputStream;
import java.net.URISyntaxException;
import javax.imageio.ImageIO;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.TargetDataLine;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;

@SuppressWarnings("serial")
public class ToneDeath extends JPanel {

    static BufferedImage background;
    static ImageIcon wallTop;
    static ImageIcon wallBottom;
    static ImageIcon wall;
    static BufferedImage pig;
    static int gameBoardWidth = 0;
    static int gameBoardHeight = 0;
    static double x = 0;
    static double y = 0;
    static int time = 0;
    static int ballSize = 30;
    static double moveSpeed;
    static double soundNormalization = .4;
    static float rms = 0;
    static boolean gameMenu = true;
    static int wallOneHoleY;
    static int wallOneHoleSize;
    static int wallOneX;
    static int wallTwoHoleY;
    static int wallTwoHoleSize;
    static int wallTwoX;
    static int wallThreeHoleY;
    static int wallThreeHoleSize;
    static int wallThreeX;
    static int wallWidth = ballSize * 6;
    static int scrollSpeed;
    static boolean gameOver = false;

    private void moveBall() {
        // x = x + 1;
        // y = y + 1;
        y = y - ((rms - soundNormalization) * moveSpeed);

        if (y > .8 * gameBoardHeight) {
            y = .8 * gameBoardHeight;
        } else if (y <= ballSize) {
            y = ballSize;
        }
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);
        Graphics2D g2d = (Graphics2D) g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
        Font font = new Font("Verdana", Font.BOLD, 25);
        g.setFont(font);
        if (gameMenu) {
            //g2d.drawImage(img, time, time, this)
            //  g2d.setColor(Color.red);
            //  g2d.fillRect((int) (.45 * gameBoardWidth), (int) (.45 * gameBoardHeight), (int) (.1 * gameBoardWidth), (int) (.1 * gameBoardHeight));
            g.drawString("To Start, be loud!", (int) (.425 * gameBoardWidth), (int) (.5 * gameBoardHeight));
            return;
        }
        //g2d.setColor(Color.CYAN);
        //g2d.fillRect(0, 0, gameBoardWidth, gameBoardHeight);
        g2d.drawImage(background, 0, 0, gameBoardWidth, gameBoardHeight, null);

        g2d.setColor(Color.black);
        //g2d.fillRect((int) x, (int) y, ballSize, ballSize);
        g2d.drawImage(pig, (int) (x - .5 * ballSize), (int) (y - .7 * ballSize), ballSize * 2, ballSize * 3, null); //crappy scalling based of looks, should use scale method 
        if (wallOneX < gameBoardWidth) {
            g2d.fillRect(wallOneX, 0, wallWidth, wallOneHoleY);
            g2d.fillRect(wallOneX, wallOneHoleY + wallOneHoleSize, wallWidth, gameBoardHeight - (wallOneHoleY + wallOneHoleSize));

            //    for (int iy = 0; iy < wallOneHoleY; iy += 50) {
            //        for (int ix = wallOneX; ix < wallOneX+wallWidth; ix += 50) {
            //            g2d.drawImage(wall.getImage(), ix-85, iy-140, null);
            //        }
            //    }
            //scaled =wall.getImage().getScaledInstance(wallWidth, wallOneHoleY, Image.SCALE_REPLICATE);
            //wallBottom.setImage(scaled);
            //g2d.drawImage(wallBottom.getImage(), wallOneX, 0, null);
            // scaled = wallTop.getImage().getScaledInstance(wallWidth, (gameBoardHeight-wallOneHoleY)-wallOneHoleSize, Image.SCALE_FAST);
            //g2d.drawImage(scaled, wallOneX,wallOneHoleY+wallOneHoleSize, null);
        }
        if (wallTwoX < gameBoardWidth) {
            g2d.fillRect(wallTwoX, 0, wallWidth, wallTwoHoleY);
            g2d.fillRect(wallTwoX, wallTwoHoleY + wallTwoHoleSize, wallWidth, gameBoardHeight - (wallTwoHoleY + wallTwoHoleSize));
        }
        if (wallThreeX < gameBoardWidth) {
            g2d.fillRect(wallThreeX, 0, wallWidth, wallThreeHoleY);
            g2d.fillRect(wallThreeX, wallThreeHoleY + wallThreeHoleSize, wallWidth, gameBoardHeight - (wallThreeHoleY + wallThreeHoleSize));
        }
        g2d.setColor(Color.darkGray);
        g.drawString("Score:" + time, (int) (.45 * gameBoardWidth), 50);
        // g2d.drawString("Time:" + time, 10, 10);
        // g2d.drawString("RMS:" + rms, 10, 20);
        // g2d.drawString("Move:" + (((double) rms - soundNormalization) * moveSpeed), 10, 30);

        g2d.setColor(Color.red);
        if (gameOver) {
            // g2d.fillRect((int) (.45 * gameBoardWidth), (int) (.45 * gameBoardHeight), (int) (.1 * gameBoardWidth), (int) (.1 * gameBoardHeight));
            g2d.drawString("Game Over", (int) (.45 * gameBoardWidth), (int) (.5 * gameBoardHeight));
        }
    }

    public boolean collisions() {
        if ((x + ballSize > wallOneX && x + ballSize < wallOneX + wallWidth) || (x > wallOneX && x < wallOneX + wallWidth)) {
            if (y < wallOneHoleY) {
                // System.out.println("trip 1");
                return true;

            }
            if (y + ballSize > wallOneHoleY + wallOneHoleSize) {
                //     System.out.println("trip 2");
                return true;

            }
        }
        if ((x + ballSize > wallTwoX && x + ballSize < wallTwoX + wallWidth) || (x > wallTwoX && x < wallTwoX + wallWidth)) {
            if (y < wallTwoHoleY) {
                //    System.out.println("trip 3");
                return true;

            }
            if (y + ballSize > wallTwoHoleY + wallTwoHoleSize) {
                //    System.out.println("trip 4");
                return true;
            }
        }
        if ((x + ballSize > wallThreeX && x + ballSize < wallThreeX + wallWidth) || (x > wallThreeX && x < wallThreeX + wallWidth)) {
            if (y < wallThreeHoleY) {
                //   System.out.println("trip 5");
                return true;
            }
            if (y + ballSize > wallThreeHoleY + wallThreeHoleSize) {
                //  System.out.println("trip 6");
                return true;
            }
        }

        return false;
    }

    public void moveWalls() {
        if (wallOneX + wallWidth < 0) {
            wallOneX = (int) (gameBoardWidth * 1.5);
            wallOneHoleY = (int) (Math.random() * gameBoardHeight * .8);
            //  if (wallOneHoleY > gameBoardHeight * .7) {
            //      wallOneHoleY = (int) (gameBoardHeight * .7);
            //  }
            wallOneHoleSize = ballSize * 10;
        }
        if (wallTwoX + wallWidth < 0) {
            wallTwoX = (int) (gameBoardWidth * 1.5);
            wallTwoHoleY = (int) (Math.random() * gameBoardHeight * .8);
            //  if (wallTwoHoleY > gameBoardHeight * .10) {
            //     wallTwoHoleY = (int) (gameBoardHeight * .7);
            // }
            wallTwoHoleSize = ballSize * 10;
        }
        if (wallThreeX + wallWidth < 0) {
            wallThreeX = (int) (gameBoardWidth * 1.5);
            wallThreeHoleY = (int) (Math.random() * gameBoardHeight * .8);
            // if (wallThreeHoleY > gameBoardHeight * .10) {
            //    wallThreeHoleY = (int) (gameBoardHeight * .7);
            // }
            wallThreeHoleSize = ballSize * 10;
        }
        wallOneX -= scrollSpeed;
        wallTwoX -= scrollSpeed;
        wallThreeX -= scrollSpeed;

    }

    public static void main(String[] args) throws InterruptedException, URISyntaxException, IOException {
        JFrame frame = new JFrame("Tone Death");
        ToneDeath game = new ToneDeath();
        frame.add(game);
        frame.setExtendedState(JFrame.MAXIMIZED_BOTH);
        frame.setUndecorated(false);
        frame.setVisible(true);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        gameBoardWidth = frame.getWidth();
        gameBoardHeight = frame.getHeight();

        //background = new ImageIcon(ToneDeath.class.getResource("src\\images\\images\\background.png"));
        InputStream stream = ToneDeath.class.getResourceAsStream("/Background.png");
        background = ImageIO.read(stream);

//wallTop = new ImageIcon("images/Tile_13.png");
        //wall = new ImageIcon("images/Object_10.png");
        //wallBottom = new ImageIcon("images/Tile_15.png");
//        pig= new ImageIcon(ToneDeath.class.getResource("/ToneDeath/images/pig.png"));
        stream = ToneDeath.class.getResourceAsStream("/pig.png");
        pig = ImageIO.read(stream);
        x = (.1 * gameBoardWidth);
        y = (.8 * gameBoardHeight);
        moveSpeed = .8 * gameBoardHeight / 30;
        //initialize walls
        wallOneHoleY = (int) (Math.random() * gameBoardHeight * .8);
        wallOneHoleSize = ballSize * 10;
        wallOneX = gameBoardWidth; //this is for the front wall
        wallTwoHoleY = (int) (Math.random() * gameBoardHeight * .8);
        wallTwoHoleSize = ballSize * 10;
        wallTwoX = (int) (gameBoardWidth * 1.5); //this is for the front wall
        wallThreeHoleY = (int) (Math.random() * gameBoardHeight * .8);
        wallThreeHoleSize = ballSize * 10;
        wallThreeX = (int) (gameBoardWidth * 2); //this is for the front wall
        scrollSpeed = (int) (gameBoardWidth / (100 * 1.5));
        //Set up Audio
        AudioFormat fmt = new AudioFormat(44100f, 16, 1, true, false);
        final int bufferByteSize = 2048;
        int b;
        TargetDataLine line;

        try {
            line = AudioSystem.getTargetDataLine(fmt);
            line.open(fmt, bufferByteSize);
        } catch (LineUnavailableException e) {
            System.err.println(e);
            return;
        }

        byte[] buf = new byte[bufferByteSize];
        float[] samples = new float[bufferByteSize / 2];

        //audio set up
        while (true) {
            time += 1;

            //Calc Sounds
            line.start();
            b = line.read(buf, 0, buf.length);
            if (b == -1) {
                System.out.println("Audio Error");
            }

            // convert bytes to samples here
            for (int i = 0, s = 0; i < b;) {
                int sample = 0;

                sample |= buf[i++] & 0xFF; // (reverse these two lines
                sample |= buf[i++] << 8;   //  if the format is big endian)

                // normalize to range of +/-1.0f
                samples[s++] = sample / 32768f;
            }

            rms = 0f;

            for (float sample : samples) {

                rms += sample * sample;
            }

            rms = (float) Math.sqrt(rms / samples.length);
            //Calc Sound
            //demo Only!!!
            gameOver = false;

            if (gameMenu) {
                if (rms > .5) {
                    gameMenu = false;

                }

            } else {
                game.moveBall();
                game.moveWalls();
                gameOver = game.collisions();
                game.repaint();
                Thread.sleep(10); //100 fps
            }
        }
    }

}
